    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018*/
    019
    020package org.apache.wiki.diff;
    021
    022import org.apache.wiki.api.core.Context;
    023
    024
    025/**
    026 * Load, initialize and delegate to the DiffProvider that will actually do the work.
    027 */
    028public interface DifferenceManager {
    029
    030    /** Property value for storing a diff provider.  Value is {@value}. */
    031    String PROP_DIFF_PROVIDER = "jspwiki.diffProvider";
    032
    033    /**
    034     * Returns valid XHTML string to be used in any way you please.
    035     *
    036     * @param context        The Wiki Context
    037     * @param firstWikiText  The old text
    038     * @param secondWikiText the new text
    039     * @return XHTML, or empty string, if no difference detected.
    040     */
    041    String makeDiff( Context context, String firstWikiText, String secondWikiText );
    042
    043    /**
    044     *  Returns a diff of two versions of a page.
    045     *  <p>
    046     *  Note that the API was changed in 2.6 to provide a WikiContext object!
    047     *
    048     *  @param context The WikiContext of the page you wish to get a diff from
    049     *  @param version1 Version number of the old page.  If WikiPageProvider.LATEST_VERSION (-1), then uses current page.
    050     *  @param version2 Version number of the new page.  If WikiPageProvider.LATEST_VERSION (-1), then uses current page.
    051     *
    052     *  @return A HTML-ized difference between two pages.  If there is no difference, returns an empty string.
    053     */
    054    String getDiff( Context context, int version1, int version2 );
    055
    056}
    057